# Module: "node_modules/bls12377js/src/bls"

## Index

### Functions

* [arrayToBuffer](_node_modules_bls12377js_src_bls_.md#arraytobuffer)
* [bigToBuffer](_node_modules_bls12377js_src_bls_.md#bigtobuffer)
* [bufferToArray](_node_modules_bls12377js_src_bls_.md#buffertoarray)
* [bufferToBig](_node_modules_bls12377js_src_bls_.md#buffertobig)
* [compressG1](_node_modules_bls12377js_src_bls_.md#compressg1)
* [compressG2](_node_modules_bls12377js_src_bls_.md#compressg2)
* [decompressG1](_node_modules_bls12377js_src_bls_.md#decompressg1)
* [decompressG2](_node_modules_bls12377js_src_bls_.md#decompressg2)
* [g1Generator](_node_modules_bls12377js_src_bls_.md#g1generator)
* [g2Generator](_node_modules_bls12377js_src_bls_.md#g2generator)
* [getMiddlePoint](_node_modules_bls12377js_src_bls_.md#getmiddlepoint)
* [padBytes](_node_modules_bls12377js_src_bls_.md#padbytes)
* [privateToPublicBytes](_node_modules_bls12377js_src_bls_.md#privatetopublicbytes)
* [reverse](_node_modules_bls12377js_src_bls_.md#reverse)
* [signPoP](_node_modules_bls12377js_src_bls_.md#signpop)
* [tryAndIncrement](_node_modules_bls12377js_src_bls_.md#tryandincrement)
* [uint8ArrayToBuffer](_node_modules_bls12377js_src_bls_.md#uint8arraytobuffer)

## Functions

###  arrayToBuffer

▸ **arrayToBuffer**(`arr`: number[]): *Buffer*

Defined in node_modules/bls12377js/src/bls.ts:34

**Parameters:**

Name | Type |
------ | ------ |
`arr` | number[] |

**Returns:** *Buffer*

___

###  bigToBuffer

▸ **bigToBuffer**(`num`: BigInteger): *Buffer*

Defined in node_modules/bls12377js/src/bls.ts:43

**Parameters:**

Name | Type |
------ | ------ |
`num` | BigInteger |

**Returns:** *Buffer*

___

###  bufferToArray

▸ **bufferToArray**(`buf`: Buffer): *number[]*

Defined in node_modules/bls12377js/src/bls.ts:30

**Parameters:**

Name | Type |
------ | ------ |
`buf` | Buffer |

**Returns:** *number[]*

___

###  bufferToBig

▸ **bufferToBig**(`buf`: Buffer): *BigInteger*

Defined in node_modules/bls12377js/src/bls.ts:38

**Parameters:**

Name | Type |
------ | ------ |
`buf` | Buffer |

**Returns:** *BigInteger*

___

###  compressG1

▸ **compressG1**(`g`: [G1](../classes/_node_modules_bls12377js_src_g1_.g1.md)): *Buffer*

Defined in node_modules/bls12377js/src/bls.ts:53

**Parameters:**

Name | Type |
------ | ------ |
`g` | [G1](../classes/_node_modules_bls12377js_src_g1_.g1.md) |

**Returns:** *Buffer*

___

###  compressG2

▸ **compressG2**(`g`: [G2](../classes/_node_modules_bls12377js_src_g2_.g2.md)): *Buffer*

Defined in node_modules/bls12377js/src/bls.ts:90

**Parameters:**

Name | Type |
------ | ------ |
`g` | [G2](../classes/_node_modules_bls12377js_src_g2_.g2.md) |

**Returns:** *Buffer*

___

###  decompressG1

▸ **decompressG1**(`bytes`: Buffer): *[G1](../classes/_node_modules_bls12377js_src_g1_.g1.md)*

Defined in node_modules/bls12377js/src/bls.ts:63

**Parameters:**

Name | Type |
------ | ------ |
`bytes` | Buffer |

**Returns:** *[G1](../classes/_node_modules_bls12377js_src_g1_.g1.md)*

___

###  decompressG2

▸ **decompressG2**(`bytes`: Buffer): *[G2](../classes/_node_modules_bls12377js_src_g2_.g2.md)*

Defined in node_modules/bls12377js/src/bls.ts:111

**Parameters:**

Name | Type |
------ | ------ |
`bytes` | Buffer |

**Returns:** *[G2](../classes/_node_modules_bls12377js_src_g2_.g2.md)*

___

###  g1Generator

▸ **g1Generator**(): *[G1](../classes/_node_modules_bls12377js_src_g1_.g1.md)*

Defined in node_modules/bls12377js/src/bls.ts:155

**Returns:** *[G1](../classes/_node_modules_bls12377js_src_g1_.g1.md)*

___

###  g2Generator

▸ **g2Generator**(): *[G2](../classes/_node_modules_bls12377js_src_g2_.g2.md)*

Defined in node_modules/bls12377js/src/bls.ts:162

**Returns:** *[G2](../classes/_node_modules_bls12377js_src_g2_.g2.md)*

___

###  getMiddlePoint

▸ **getMiddlePoint**(): *BigInteger*

Defined in node_modules/bls12377js/src/bls.ts:48

**Returns:** *BigInteger*

___

###  padBytes

▸ **padBytes**(`buf`: Buffer, `expectedLength`: number): *Buffer*

Defined in node_modules/bls12377js/src/bls.ts:175

**Parameters:**

Name | Type |
------ | ------ |
`buf` | Buffer |
`expectedLength` | number |

**Returns:** *Buffer*

___

###  privateToPublicBytes

▸ **privateToPublicBytes**(`privateKey`: Buffer): *Buffer*

Defined in node_modules/bls12377js/src/bls.ts:186

**Parameters:**

Name | Type |
------ | ------ |
`privateKey` | Buffer |

**Returns:** *Buffer*

___

###  reverse

▸ **reverse**(`src`: Buffer): *Buffer‹›*

Defined in node_modules/bls12377js/src/bls.ts:10

**Parameters:**

Name | Type |
------ | ------ |
`src` | Buffer |

**Returns:** *Buffer‹›*

___

###  signPoP

▸ **signPoP**(`privateKey`: Buffer, `address`: Buffer): *Buffer*

Defined in node_modules/bls12377js/src/bls.ts:192

**Parameters:**

Name | Type |
------ | ------ |
`privateKey` | Buffer |
`address` | Buffer |

**Returns:** *Buffer*

___

###  tryAndIncrement

▸ **tryAndIncrement**(`domain`: Buffer, `message`: Buffer): *[G1](../classes/_node_modules_bls12377js_src_g1_.g1.md)*

Defined in node_modules/bls12377js/src/bls.ts:204

**Parameters:**

Name | Type |
------ | ------ |
`domain` | Buffer |
`message` | Buffer |

**Returns:** *[G1](../classes/_node_modules_bls12377js_src_g1_.g1.md)*

___

###  uint8ArrayToBuffer

▸ **uint8ArrayToBuffer**(`src`: Uint8Array): *Buffer*

Defined in node_modules/bls12377js/src/bls.ts:21

**Parameters:**

Name | Type |
------ | ------ |
`src` | Uint8Array |

**Returns:** *Buffer*
